import { OnInit, OnChanges, SimpleChanges, ElementRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import CodeMirror from 'codemirror';
export declare class CodemirrorComponent implements OnInit, OnChanges, ControlValueAccessor {
    private $el;
    mode: string | undefined;
    theme: string | undefined;
    lineNumbers: boolean | undefined;
    viewportMargin: number | undefined;
    protected codemirror: CodeMirror.Editor;
    private defaultValue;
    private defaults;
    constructor($el: ElementRef, defaults: CodeMirror.EditorConfiguration);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    writeValue(value: string): void;
    registerOnChange(fn: (_: any) => void): void;
    registerOnTouched(fn: () => void): void;
    private onChange;
    private onTouched;
}
